Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.rmi.server
Class RMISocketFactory

    java.lang.Object
      |
      +--java.rmi.server.RMISocketFactory

All Implemented Interfaces:
  RMIClientSocketFactory, RMIServerSocketFactory

public abstract class RMISocketFactory
extends Object
implements RMIClientSocketFactory, RMIServerSocketFactory

An `RMISocketFactory` instance is used by the RMI runtime in order to obtain client and server sockets for RMI calls. An application may use the `setSocketFactory` method to request that the RMI runtime use its socket factory instance instead of the default implementation.

The default socket factory implementation used goes through a three-tiered approach to creating client sockets. First, a direct socket connection to the remote VM is attempted. If that fails (due to a firewall), the runtime uses HTTP with the explicit port number of the server. If the firewall does not allow this type of communication, then HTTP to a cgi-bin script on the server is used to POST the RMI call.

Since:
  JDK1.1

Constructor Summary
`RMISocketFactory()` Constructs an `RMISocketFactory`.

Method Summary
`abstract ServerSocket` | `createServerSocket(int port)` Create a server socket on the specified port (port 0 indicates an anonymous port).
`abstract Socket` | `createSocket(String host, int port)` Creates a client socket connected to the specified host and port.
`static RMISocketFactory` | `getDefaultSocketFactory()` Returns a reference to the default socket factory used by this RMI implementation.
`static RMIFailureHandler` | `getFailureHandler()` Returns the handler for socket creation failure set by the `setFailureHandler` method.
`static RMISocketFactory` | `getSocketFactory()` Returns the socket factory set by the `setSocketFactory` method.
`static void` | `setFailureHandler(RMIFailureHandler fh)` Sets the failure handler to be called by the RMI runtime if server socket creation fails.
`static void` | `setSocketFactory(RMISocketFactory fac)` Set the global socket factory from which RMI gets sockets (if the remote object is not associated with a specific client and/or server socket factory).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RMISocketFactory

    public RMISocketFactory()

  Constructs an `RMISocketFactory`.
  Since:
    JDK1.1

Method Detail

### createSocket

    public abstract Socket createSocket(String host,
                                        int port)
                                 throws IOException

  Creates a client socket connected to the specified host and port.
  Specified by:
    `createSocket` in interface `RMIClientSocketFactory`
  Parameters:
    `host` - the host name
    `port` - the port number
  Returns:
    a socket connected to the specified host and port.
  Throws:
    `IOException` - if an I/O error occurs during socket creation
  Since:
    JDK1.1

### createServerSocket

    public abstract ServerSocket createServerSocket(int port)
                                             throws IOException

  Create a server socket on the specified port (port 0 indicates an anonymous port).
  Specified by:
    `createServerSocket` in interface `RMIServerSocketFactory`
  Parameters:
    `port` - the port number
  Returns:
    the server socket on the specified port
  Throws:
    `IOException` - if an I/O error occurs during server socket creation
  Since:
    JDK1.1

### setSocketFactory

    public static void setSocketFactory(RMISocketFactory fac)
                                 throws IOException

  Set the global socket factory from which RMI gets sockets (if the remote object is not associated with a specific client and/or server socket factory). The RMI socket factory can only be set once. Note: The RMISocketFactory may only be set if the current security manager allows setting a socket factory; if disallowed, a SecurityException will be thrown.
  Parameters:
    `fac` - the socket factory
  Throws:
    `IOException` - if the RMI socket factory is already set
    `SecurityException` - if a security manager exists and its `checkSetFactory` method doesn't allow the operation.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkSetFactory()`

### getSocketFactory

    public static RMISocketFactory getSocketFactory()

  Returns the socket factory set by the `setSocketFactory` method. Returns `null` if no socket factory has been set.
  Returns:
    the socket factory
  Since:
    JDK1.1
  See Also:
    `setSocketFactory(RMISocketFactory)`

### getDefaultSocketFactory

    public static RMISocketFactory getDefaultSocketFactory()

  Returns a reference to the default socket factory used by this RMI implementation. This will be the factory used by the RMI runtime when `getSocketFactory` returns `null`.
  Returns:
    the default RMI socket factory
  Since:
    JDK1.1

### setFailureHandler

    public static void setFailureHandler(RMIFailureHandler fh)

  Sets the failure handler to be called by the RMI runtime if server socket creation fails. By default, if no failure handler is installed and server socket creation fails, the RMI runtime does attempt to recreate the server socket.
  Parameters:
    `fh` - the failure handler
  Since:
    JDK1.1
  See Also:
    `RMIFailureHandler.failure(Exception)`

### getFailureHandler

    public static RMIFailureHandler getFailureHandler()

  Returns the handler for socket creation failure set by the `setFailureHandler` method.
  Returns:
    the failure handler
  Since:
    JDK1.1
  See Also:
    `setFailureHandler(RMIFailureHandler)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.